"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var NodeInformationFrame_exports = {};
__export(NodeInformationFrame_exports, {
  determineNIF: () => determineNIF
});
module.exports = __toCommonJS(NodeInformationFrame_exports);
var import_core = require("@zwave-js/core");
function determineNIF() {
  const basicDeviceClass = import_core.BasicDeviceClass["Static Controller"];
  const genericDeviceClass = 1;
  const specificDeviceClass = 0;
  return {
    basicDeviceClass,
    genericDeviceClass,
    specificDeviceClass,
    supportedCCs: [
      import_core.CommandClasses["Z-Wave Plus Info"],
      import_core.CommandClasses.Security,
      import_core.CommandClasses["Security 2"],
      import_core.CommandClasses["Transport Service"],
      import_core.CommandClasses.Supervision,
      import_core.CommandClasses["CRC-16 Encapsulation"],
      import_core.CommandClasses["Multi Command"],
      import_core.CommandClasses["Inclusion Controller"]
    ],
    // CC:0000.00.00.12.004: It is NOT RECOMMENDED to advertise controlled Command Classes.
    controlledCCs: []
  };
}
__name(determineNIF, "determineNIF");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  determineNIF
});
//# sourceMappingURL=NodeInformationFrame.js.map
