"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var utils_exports = {};
__export(utils_exports, {
  evalOrStatic: () => evalOrStatic,
  highResTimestamp: () => highResTimestamp,
  noop: () => noop
});
module.exports = __toCommonJS(utils_exports);
function highResTimestamp() {
  if (typeof process !== "undefined") {
    const [s, ns] = process.hrtime();
    return s * 1e9 + ns;
  } else if (performance != void 0) {
    return performance.now() * 1e6;
  } else {
    throw new Error("No high-resolution timer available");
  }
}
__name(highResTimestamp, "highResTimestamp");
function noop() {
}
__name(noop, "noop");
function evalOrStatic(fnOrConst, ...args) {
  return typeof fnOrConst === "function" ? fnOrConst(...args) : fnOrConst;
}
__name(evalOrStatic, "evalOrStatic");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  evalOrStatic,
  highResTimestamp,
  noop
});
//# sourceMappingURL=utils.js.map
